//###################################################################################
 //Needs to Fix:
 //1)START_STOP_Button when pressed stops the timer
 //2)Time on display in this format HH:MM -- Fixed
 //3)Blink on LCD display needs to work when timer is ON
 //4)led_RED is ON when Start_Stop button is pressed --Fixed
 //5)Led_Gr/Yel or Blue need to Blink every sec when ON (Start_Stop) is pressed
 //6)When Enable signal from IR is active then all Relays close and timer resets
 //7) Date: 2019-02-26
//###################################################################################

// LCD module connections
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;

sbit Relay_1 at RA0_bit;
sbit Relay_2 at RA1_bit;
sbit Relay_3 at RA2_bit;

//Outputs:LEDs
sbit led_RED at RC5_bit;         // led Red for Start/Stop of timers
sbit led_GREEN at RA4_bit;       // led Green for 30 mins
sbit led_YELLOW at RA5_bit;      // led Yellow for 3 hrs
sbit led_BLUE at RB0_bit;        // led Blue for 8 hrs

//Outputs: Buzzer
sbit Buzzer at RB1_bit; //Buzzer

//Inputs: Tact Switches and external signal
sbit Start_Stop_Button at RC0_bit;     // Starts or Stops Timer Select
sbit Min30_Button at RC1_bit;          // Set 30 min timer
sbit Hour2_Button at RC2_bit;          // Set 3 hours timer
sbit Hour5_Button at RA3_bit;          // Set 8 hours timer
sbit Oven_OFF at RC7_bit;              //  Close oven and all 3Relays

//sbit Off_3Relays at RA4_bit; // Shutdown all 3 relays
// Messages
char Message1[]="30min-5hr:Timer OFF";
char Message2[]="Timer OFF";
char Message3[]="Timer ON: HH:MM";
char Message4[]="Set Time: ";
char Message5[]="Time Left: ";
unsigned int i, j, v, unit= 0, ten=0, cent=0, Start_Stop=0, index=0, clear, time;
char *digit[5] = "0:00";
unsigned int HHMM_Pos[] = {6, 7, 8, 9, 10};
unsigned short Blink;

//300ms Delay
void Delay_300(){
    Delay_ms(300);
}
void debounce(){
    Delay_ms(250);
}
// convert minutes to ASCII hours and minutes
Display_Hours(){
unsigned int dminutes;

    dminutes = (unit + (ten * 10) + (100 * cent));    // put minutes into one varible
    digit[0] = (dminutes / 60) + 48;                  // hours as ascii
    dminutes %= 60;
    digit[1] = ':';
    digit[2] = (dminutes / 10) + 48;
    digit[3] = (dminutes %10) +48;
    digit[4] = 0;                                     // null terminator
    Lcd_Out(2,11,digit);
}

//Display digits functions
void Display_Digits(){
    digit[2]=unit+48;
    digit[1]=ten+48;
    digit[0]=cent+48;
    Lcd_Out(2,11,digit);
}

// Buzzer sound
void Play_Sound(){
    //Sound_Play(1000, 1000);
    Buzzer=1;
    Delay_ms(1000);
    Buzzer=0;
    /*Delay_ms(1000);
    Buzzer=1;
    Delay_ms(1000);
    Buzzer=0;*/
}

//Timer function
void start_timer(int MinVal){
unsigned  temp1, temp2, temp3;
unsigned int dminutes;

    Play_Sound();
    Relay_1 = 1;
    Relay_2 = 1;
    Relay_3 = 1;
    Start_Stop = 0;
    led_RED = 1;
    Lcd_Cmd(_LCD_CLEAR);           // Clear LCD
    Lcd_Out(1,1,Message2);         // "Timer OFF"
    Lcd_Out(1,1,Message3);         // "Timer ON: HH:MM"
    Lcd_Out(2,1,Message5);         // "Time Left: "

    OPTION_REG = 0x80 ;            // bit7 Enable PORTB Pull UP
    T1CON = 0x90;                  // Enable Global Interupt
    INTCON = 0x90;                 // C8 Enable Global Interupt
    T1CON = 0b00000001;
    TMR1L = 0xF0;
    TMR1H = 0xFF;
    ADCON1 = 0x07;
    for (i=0; i<MinVal; i++){
       temp1 = (MinVal-i) % 10;
       temp2 = ((MinVal-i)/10)%10;
       temp3 = ((MinVal-i)/100)%10;
       dminutes = minval-i;                       // put minutes into one varible
       Lcd_Chr(2, 12,  (dminutes / 60) + 48);     // hours as ascii
       dminutes %= 60;
       Lcd_Chr(2, 13,  ':');
    Lcd_Chr(2, 14, (dminutes / 10) + 48);
    Lcd_Chr(2, 15, (dminutes %10) +48);
       j = 1;
       do {
           Delay_ms(1000);
           j++;
       } while(((j<=60) && (Clear ==0)));
       if (Clear) {
           Delay_ms(500);
           Lcd_Out(1,1,Message2);
           INTCON = 0x00;
           goto stop;
             /*-------------------*/
          if(!Start_Stop){  // pressing button while running break the timer loop + put timer in stop
             Delay_ms(100);    // press and hold button just for  make sure program pass this point
             if (START_STOP == 1){
             goto stop;
             }
            }
           /*--------------------*/
       }
    }
stop:
    Relay_1 = 0;
    Relay_2 = 0;
    Relay_3 = 0;
    led_BLUE = 0;
    led_RED = 0;
    led_GREEN = 0;
    led_YELLOW = 0;
    unit = 0;
    ten = 0;
    cent = 0;
    clear = 1;
    Start_Stop = 1;
    Play_Sound();
    Lcd_Out(1,1,Message2);
}

//Interupt
void interrupt(void){
    if (INTCON.INTF == 1){              // Check if INTF flag is set{
        Clear = 1;
        INTCON.INTF = 0;               // Clear interrupt flag before exiting ISR
        Blink = ~Blink;
    }
}

void main() {
    ANSEL = 0x00;
    ANSELH = 0x00;
    CM1CON0 = 7;                     // Disable Comparators
    TRISA = 0b11001000;              // TRISA = 0b11110000;
    TRISB = 0b00000000;              // TRISB = 0b00001111;
    TRISC = 0b11001111;              // TRISC = 0b00001111;
    Relay_1 = 0;                     // RA0
    Relay_2 = 0;                     // RA1
    Relay_3 = 0;                     // RA2
    led_BLUE = 0;                    // RB0
    led_RED = 0;                     // RC5
    led_GREEN = 0;                   // RA4
    led_YELLOW = 0;                  // RA5
    Sound_Init(&PORTB,1);            // Initialize Buzzer pin #1
    Lcd_Init();                      // Initialize LCD
start:
    clear = 0;
    Lcd_Cmd(_LCD_CLEAR);                 // Clear display
    Lcd_Cmd(_LCD_CURSOR_OFF);            // Cursor off
    Lcd_Out(1,1, "OvenGUARD R1.0");
    Lcd_Out(2,1, "Nagatronic AB");
    i=0;
    while(i<4){
         debounce();
         i ++;
    }
    Lcd_Out(1,1,Message1);              // "30min-5hr:Timer OFF"
    Lcd_Out(2,1,Message4);              // "Set Time: "
    Display_Hours();                    //Display_Digits

    do {
        if(Min30_Button == 0){         // RC1 - 30 minute button is pressed
            Delay_300();
            cent = 0;
            ten = 0;                   //
            unit = 30;                  // 10 minutes time for test purpose
            led_GREEN = 1;
            Display_Hours();
        } // If !Min30_Button
        
        if(Hour2_Button == 0){          // RC2 - 2 hours(120 min) button is pressed
            Delay_300();
            cent = 1;
            ten = 2;
            unit = 0;
            led_YELLOW = 1;             // RA5
            Display_Hours();
        } // If !Hour2_Button
        
        if(Hour5_Button == 0){          // RA3 - 5 hour(300 min) button is pressed
            Delay_300();
            cent = 3;
            ten = 0;
            unit = 0;
            led_BLUE = 1;               // RB0
            Display_Hours();
        } // If !Hour5_Button
        
        if(Start_Stop_Button == 0){     // Start_Stop button is pressed
            Delay_300();
            time = cent*100 + ten*10 + unit ;  //unit
            if(time > 0) start_timer(time);
        } // If !Start_Stop_Button
        if(clear){
            goto start;
        }
    } while(1);
}