#line 1 "E:/Spisvakt_1.4a_07_11/Spisvakt_1.4a.c"
#line 13 "E:/Spisvakt_1.4a_07_11/Spisvakt_1.4a.c"
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;

sbit Relay_1 at RA0_bit;
sbit Relay_2 at RA1_bit;
sbit Relay_3 at RA2_bit;


sbit led_RED at RC5_bit;
sbit led_GREEN at RA4_bit;
sbit led_YELLOW at RA5_bit;
sbit led_BLUE at RB0_bit;


sbit Buzzer at RB1_bit;


sbit Start_Stop_Button at RC0_bit;
sbit Min30_Button at RC1_bit;
sbit Hour2_Button at RC2_bit;
sbit Hour5_Button at RA3_bit;
sbit Oven_OFF at RC7_bit;



char Message1[]="30min-5hr:Timer OFF";
char Message2[]="Timer OFF";
char Message3[]="Timer ON: HH:MM";
char Message4[]="Set Time: ";
char Message5[]="Time Left: ";
unsigned int i, j, v, unit= 0, ten=0, cent=0, Start_Stop=0, index=0, clear, time;
char *digit[5] = "0:00";
unsigned int HHMM_Pos[] = {6, 7, 8, 9, 10};
unsigned short Blink;


void Delay_300(){
 Delay_ms(300);
}
void debounce(){
 Delay_ms(250);
}

Display_Hours(){
unsigned int dminutes;

 dminutes = (unit + (ten * 10) + (100 * cent));
 digit[0] = (dminutes / 60) + 48;
 dminutes %= 60;
 digit[1] = ':';
 digit[2] = (dminutes / 10) + 48;
 digit[3] = (dminutes %10) +48;
 digit[4] = 0;
 Lcd_Out(2,11,digit);
}


void Display_Digits(){
 digit[2]=unit+48;
 digit[1]=ten+48;
 digit[0]=cent+48;
 Lcd_Out(2,11,digit);
}


void Play_Sound(){

 Buzzer=1;
 Delay_ms(1000);
 Buzzer=0;
#line 97 "E:/Spisvakt_1.4a_07_11/Spisvakt_1.4a.c"
}


void start_timer(int MinVal){
unsigned temp1, temp2, temp3;
unsigned int dminutes;

 Play_Sound();
 Relay_1 = 1;
 Relay_2 = 1;
 Relay_3 = 1;
 Start_Stop = 0;
 led_RED = 1;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,Message2);
 Lcd_Out(1,1,Message3);
 Lcd_Out(2,1,Message5);

 OPTION_REG = 0x80 ;
 T1CON = 0x90;
 INTCON = 0x90;
 T1CON = 0b00000001;
 TMR1L = 0xF0;
 TMR1H = 0xFF;
 ADCON1 = 0x07;
 for (i=0; i<MinVal; i++){
 temp1 = (MinVal-i) % 10;
 temp2 = ((MinVal-i)/10)%10;
 temp3 = ((MinVal-i)/100)%10;
 dminutes = minval-i;
 Lcd_Chr(2, 12, (dminutes / 60) + 48);
 dminutes %= 60;
 Lcd_Chr(2, 13, ':');
 Lcd_Chr(2, 14, (dminutes / 10) + 48);
 Lcd_Chr(2, 15, (dminutes %10) +48);
 j = 1;
 do {
 Delay_ms(1000);
 j++;
 } while(((j<=60) && (Clear ==0)));
 if (Clear) {
 Delay_ms(500);
 Lcd_Out(1,1,Message2);
 INTCON = 0x00;
 goto stop;

 if(!Start_Stop){
 Delay_ms(100);
 if (START_STOP == 1){
 goto stop;
 }
 }

 }
 }
stop:
 Relay_1 = 0;
 Relay_2 = 0;
 Relay_3 = 0;
 led_BLUE = 0;
 led_RED = 0;
 led_GREEN = 0;
 led_YELLOW = 0;
 unit = 0;
 ten = 0;
 cent = 0;
 clear = 1;
 Start_Stop = 1;
 Play_Sound();
 Lcd_Out(1,1,Message2);
}


void interrupt(void){
 if (INTCON.INTF == 1){
 Clear = 1;
 INTCON.INTF = 0;
 Blink = ~Blink;
 }
}

void main() {
 ANSEL = 0x00;
 ANSELH = 0x00;
 CM1CON0 = 7;
 TRISA = 0b11001000;
 TRISB = 0b00000000;
 TRISC = 0b11001111;
 Relay_1 = 0;
 Relay_2 = 0;
 Relay_3 = 0;
 led_BLUE = 0;
 led_RED = 0;
 led_GREEN = 0;
 led_YELLOW = 0;
 Sound_Init(&PORTB,1);
 Lcd_Init();
start:
 clear = 0;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1, "OvenGUARD R1.0");
 Lcd_Out(2,1, "Nagatronic AB");
 i=0;
 while(i<4){
 debounce();
 i ++;
 }
 Lcd_Out(1,1,Message1);
 Lcd_Out(2,1,Message4);
 Display_Hours();

 do {
 if(Min30_Button == 0){
 Delay_300();
 cent = 0;
 ten = 0;
 unit = 30;
 led_GREEN = 1;
 Display_Hours();
 }

 if(Hour2_Button == 0){
 Delay_300();
 cent = 1;
 ten = 2;
 unit = 0;
 led_YELLOW = 1;
 Display_Hours();
 }

 if(Hour5_Button == 0){
 Delay_300();
 cent = 3;
 ten = 0;
 unit = 0;
 led_BLUE = 1;
 Display_Hours();
 }

 if(Start_Stop_Button == 0){
 Delay_300();
 time = cent*100 + ten*10 + unit ;
 if(time > 0) start_timer(time);
 }
 if(clear){
 goto start;
 }
 } while(1);
}
